import collections

def bfs(graph, start, max_dist):
    queue = collections.deque([(start, 0)])
    visited = {start}
    reachable = {start}
    while queue:
        node, dist = queue.popleft()
        if dist < max_dist:
            for neighbor in graph.get(node, []):
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))
                    reachable.add(neighbor)
    return reachable

def solve():
    n, m, k = map(int, input().split())
    graph = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        graph[u].append(v)
        graph[v].append(u)

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    guarded_nodes = set()
    for guard_pos, guard_range in guards:
        guarded_nodes.update(bfs(graph, guard_pos, guard_range))

    result = sorted(list(guarded_nodes))
    print(len(result))
    if result:
        print(*result)


solve()
